/*
    CaPriCe Forever - Amstrad CPC 464/664/6128 emulator
    Copyright (C) 2014-2018 by Frédéric Coste

    This program is free software: you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation, either version 3 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program.  If not, see <http://www.gnu.org/licenses/>.
*/


#include <vcl.h>
#pragma hdrstop
#include "TCheatActionTapeMotor.h"

//---------------------------------------------------------------------------

#pragma package(smart_init)


__fastcall TCheatActionTapeMotor::TCheatActionTapeMotor(AnsiString Command) : TCheatAction()
//
// Constructor
//
{
  mBranchToLabel = false;

  int ParamPos = Command.Pos("=");
  int ParamLength = Command.Length() - ParamPos;
  int CommentPos = Command.Pos(";");

  if (CommentPos)
  {
    ParamLength = CommentPos - ParamPos - 1;
  }
  else
  {
    CommentPos = Command.Length();
  }

  if (ParamPos < CommentPos)
  {
    AnsiString Param = Command.SubString(ParamPos+1, ParamLength).Trim();
    int SeparatorPos = Param.Pos(":");

    // Value
    AnsiString StringValue = Param.SubString(1, SeparatorPos-1).Trim();

    // Branch label
    mBranchLabel = Param.SubString(SeparatorPos+1, Param.Length()).Trim();

    try
    {
      if (StringValue.Trim().LowerCase() == "on")
      {
        mExpectedValue = 1;
      }
      else if (StringValue.Trim().LowerCase() == "off")
      {
        mExpectedValue = 0;
      }
      else
      {
        mExpectedValue = StringValue.ToInt();
        if (mExpectedValue != 0)
        {
          mExpectedValue = 1;
        }
      }
    }
    catch(...)
    {
      mExpectedValue = -1;
    }

    
    // Check validity
    if ( ( (mExpectedValue == 0) || (mExpectedValue == 1) )
         && (mBranchLabel.IsEmpty() == false) )
    {
      mValid = true;
    }
  }
}
//---------------------------------------------------------------------------


__fastcall TCheatActionTapeMotor::~TCheatActionTapeMotor(void)
//
// Destructor
//
{
}
//---------------------------------------------------------------------------


void __fastcall TCheatActionTapeMotor::Execute(tNativeCPC* NativeCPC)
{
  tULong TapeMotor = NativeCPC->Tape->tape_motor == 0 ? 0 : 1;

  // read value is different ?
  if (TapeMotor == mExpectedValue)
  {
    mBranchToLabel = true;
  }
}
//---------------------------------------------------------------------------


AnsiString __fastcall TCheatActionTapeMotor::NextAction(void)
{
  return (mBranchToLabel == true ? mBranchLabel : (AnsiString)NULL);
}
//---------------------------------------------------------------------------


